#!/usr/bin/python3

# ## {R2D2919B742E} ##
# ###########################################################################
# What if magic existed?
# What if a place existed where your every thought and dream come to life.
# There is only one catch: it has to be written down.
# Such a place exists, it is called programming.
#    - Scott Taylor Reph, RightThumb.com
# ###########################################################################
# ## {C3P0D40fAe8B} ##
##################################################
import os, sys, time
##################################################
import _rightThumb._construct as __
appDBA = __.clearFocus( __name__, __file__ )
__.appReg = appDBA
def focus( parentApp='', childApp='', reg=True ):
    global appDBA
    f = __.appName( appDBA, parentApp, childApp )
    if reg:
        __.appReg = f
    return f
__.registeredApps.append( focus() )
import _rightThumb._base3 as _
_.load()
##################################################
import _rightThumb._vars as _v
import _rightThumb._string as _str
##################################################

def appSwitches():
    pass

_.autoBackupData = __.setting('receipt-log')
__.releaseAcquiredData = __.setting('receipt-file')
__.myFileLocations_SKIP_VALIDATION = False
__.isRequired_Pipe = False
__.isRequired_Pipe_or_File = False
__.pre_error = False
__.switch_raw = []
# __.switch_raw = [ 'Delim' ]
# __.isRequired_or_List = ['Pipe','Files','Plus']
# __.setting( 'app-switches-raw', [ 'Delim' ] )


_.appInfo[focus()] = {
    'file': 'vps-hoth-7i0ZA-7GzGHN-daily-texter.py',
    'liveAppName': __.thisApp( __file__ ),
    'description': 'sends texts on a schedule',
        # _.ail(1,'subject')+
        # _.aib('one')+
    'categories': [
                        'text',
                        'twilo',
                ],
    'usage': [
                        # 'epy another',
                        # 'e nmap',
                        # '',
    ],
    'relatedapps': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'prerequisite': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'examples': [
                        _.hp('p vps-hoth-7i0ZA-7GzGHN-daily-texter'),
                        '',
    ],
    'columns': [
                       # { 'name': 'name', 'abbreviation': 'n' },
                       # { 'name': '{1}', 'abbreviation': '{0}', 'sort': '{2}' },
    ],
    'aliases': [
                       # 'this',
                       # 'app',
    ],
    'notes': [
                       # {},
    ],
}

_.appData[focus()] = {
        'start': __.startTime,
        'uuid': '',
        'audit': [],
        'pipe': False,
        'data': {
                    'field': {'sent': [], 'received': [] }, # { 'label': '', 'context': [],  }
                    'table': {'sent': [], 'received': [] }, 
        },
    }



def registerSwitches( argvProcessForce=False ):
    global appDBA
    if not __.appReg == appDBA and appDBA in __.appReg:

        if not __name__ == '__main__':
            _.argvProcess = argvProcessForce
        else:
            _.argvProcess = True

        _.load()
        _.appInfo[__.appReg] = _.appInfo[appDBA]
        _.appData[__.appReg] = _.appData[appDBA]
    __.constructRegistration( _.appInfo[__.appReg]['file'],__.appReg )
    appSwitches()

    _.myFileLocation_Print = False
    _.switches.trigger( 'Files', _.myFileLocations, vs=True )
    _.switches.trigger( 'Folder', _.myFolderLocations )
    _.switches.trigger( 'URL', _.urlTrigger )
    _.switches.trigger( 'Ago', _.timeAgo )
    _.switches.trigger( 'Duration', _.timeFuture )
    
    _.defaultScriptTriggers()
    _.switches.process()


if not __name__ == '__main__':
    _.argvProcess = False
else:
    _.argvProcess = True

registerSwitches()


def fieldSet( switchName, switchField, switchValue, theFocus=False ):
    if not type( theFocus ) == bool:
        theFocus = theFocus
    _.switches.fieldSet( switchName, switchField, switchValue, theFocus )


if __name__ == '__main__':
    if not sys.stdin.isatty():
        _.setPipeData( sys.stdin.readlines(), __.appReg, clean=True )


_.postLoad( __file__ )

########################################################################################
# START



def action():
    load()
    global data

    log=_.getTable('vps-hoth-7i0ZA-7GzGHN-daily-texter.json')
    index=_.getTable('vps-hoth-7i0ZA-7GzGHN-daily-texter.index')
    errors=_.getTable('vps-hoth-7i0ZA-7GzGHN-daily-texter-err.json')
    ran=False
    err=False
    day = _.friendlyDate(time.time()).split(' ')[0]
    for i,rec in enumerate( data ):
        if rec['date-renew'] and rec['date-renew']['iso'].startswith(day):
            rid = rec['date-renew']['id']
            if not rid in index:
                wasSent='N) '
                if not len(rec['phone']) < 6:
                    wasSent='-) '

                if rec['textme']:
                    for phone in rec['phone'].replace(' ','').split(','):
                        try:
                            _send.imp.action( to=phone, body=rec['title-renew'] )
                            ran=True; log.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-renew'], 'admin': False });
                            index[rid]={ 'client': rec['client'], 'phone': phone, 'body': rec['title-renew'], 'admin': False }
                            wasSent='Y) '
                        except Exception as e:
                            wasSent='E) '
                            err=True; errors.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-renew'], 'admin': False });
                            pass
                # for phone in '813-690-1260 813-957-3524 813-503-5938'.split(' '):
                for phone in '813-690-1260'.split(' '):
                    try:
                        _send.imp.action( to=phone, body=wasSent+rec['title-renew'] )
                        ran=True; log.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-renew'], 'admin': True });
                    except Exception as e:
                        err=True; errors.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-renew'], 'admin': True });
                        pass

        if rec['date-expire'] and rec['date-expire']['iso'].startswith(day):
            rid = rec['date-expire']['id']
            if not rid in index:
                wasSent='N) '
                if not len(rec['phone']) < 6:
                    wasSent='-) '
                if rec['textme']:
                    for phone in rec['phone'].replace(' ','').split(','):
                        try:
                            _send.imp.action( to=phone, body=rec['title-expire'] )
                            ran=True; log.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-expire'], 'admin': False });
                            index[rid]={ 'client': rec['client'], 'phone': phone, 'body': rec['title-expire'], 'admin': False }
                            wasSent='Y) '
                        except Exception as e:
                            wasSent='E) '
                            err=True; errors.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-expire'], 'admin': False });
                            pass
                # for phone in '813-690-1260 813-957-3524 813-503-5938'.split(' '):
                for phone in '813-690-1260'.split(' '):
                    try:
                        _send.imp.action( to=phone, body=wasSent+rec['title-expire'] )
                        ran=True; log.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-expire'], 'admin': True });
                    except Exception as e:
                        err=True; errors.append({ 'client': rec['client'], 'phone': phone, 'body': rec['title-expire'], 'admin': True });
                        pass
    if err:
        _.saveTable( errors, 'vps-hoth-7i0ZA-7GzGHN-daily-texter-err.json' )
    if ran:
        _.saveTable( log, 'vps-hoth-7i0ZA-7GzGHN-daily-texter.json' )
        _.saveTable( index, 'vps-hoth-7i0ZA-7GzGHN-daily-texter.index' )

        


def load():
    global data
    data = _.getTable2( '/home/admin/domains/eyeformeta.com/private_html/apps/clients/7i0ZA/gps/texts-E304AC38-A5E6.json' )

_send =  _.regImp( __.appReg, 'vps-srv-7facG-twilio-send' )


########################################################################################
if __name__ == '__main__':
    action()
    __.isExit()




